﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml;
using Infragistics.Windows.DockManager;
using XamDockManagerTesting.Behavior;

namespace XamDockManagerTesting
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ViewModel vm;
        public MainWindow()
        {
            InitializeComponent();
            vm = new ViewModel();
            this.DataContext = vm;
        }

        private void dockManager_ActivePaneChanged(object sender, RoutedPropertyChangedEventArgs<Infragistics.Windows.DockManager.ContentPane> e)
        {

        }

        private void dockManager_ToolWindowLoaded(object sender, Infragistics.Windows.DockManager.Events.PaneToolWindowEventArgs e)
        {

        }

        private void dockManager_ToolWindowUnloaded(object sender, Infragistics.Windows.DockManager.Events.PaneToolWindowEventArgs e)
        {

        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            int count = vm.Items.Count + 1;
            if (count % 2 == 0)
                vm.Items.Add(new O2("Tab " + count, "Z" + count));
            else
                vm.Items.Add(new O1("Tab " + count, "Z" + count));
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            FileStream fs = null;
            try
            {
                fs = new FileStream(@"C:\Temp\layout.xml", FileMode.Create, FileAccess.Write);
                this.dockManager.SaveLayout(fs);
                //MessageBox.Show("FileLocation: " + fs.Name, "Saved");
            }
            catch (Exception damn)
            {
                MessageBox.Show(damn.ToString(), "Damn ... something went wrong");
            }
            finally
            {
                if (fs != null)
                    fs.Close();
            }
        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            FileStream fs = null;
            try
            {
                string filePath = @"C:\Temp\layout.xml";

                fs = new FileStream(filePath, FileMode.Open, FileAccess.Read);
                this.dockManager.LoadLayout(fs);
                //// <--
                ////var dc = this.dockManager.DataContext;
                ////this.dockManager.DataContext = null;

                //var contentHost = this.dockManager.Content as DocumentContentHost;

                //var paneDC = contentHost.Panes[0].Panes[0].DataContext;
                //contentHost.Panes[0].Panes[0].DataContext = null;

                //TabGroupPaneItemsSourceBehavior behavior = new TabGroupPaneItemsSourceBehavior();
                //behavior.HeaderMemberPath = "Header";
                //behavior.HeaderTemplate = (DataTemplate)dockManager.Resources["HeaderTemplate"];
                //behavior.ItemTemplate = (DataTemplate)dockManager.Resources["ItemTemplate"];
                //BindingOperations.SetBinding(behavior, TabGroupPaneItemsSourceBehavior.ItemsSourceProperty, new Binding("Items"));
                //var behaviorCollection = System.Windows.Interactivity.Interaction.GetBehaviors(contentHost.Panes[0].Panes[0]);
                //behaviorCollection.Add(behavior);

                //contentHost.Panes[0].Panes[0].DataContext = paneDC;

                ////-->
                ////this.dockManager.DataContext = dc;

            }
            catch (Exception damn)
            {
                MessageBox.Show(damn.ToString(), "Damn ... something went wrong");
            }
            finally
            {
                if (fs != null)
                    fs.Close();
            }
        }

        private void Button_Click_3(object sender, RoutedEventArgs e)
        {
            if (vm.Items.Any())
                vm.Items.Remove(vm.Items.Last());
        }

        private void dockManager_LayoutUpdated(object sender, EventArgs e)
        {

        }
    }
}
